/**************************************************************************\
 FILE ..........: RPM.C
 AUTHOR ........: Vitaly Puzrin
 DESCRIPTION ...:     (  )
 NOTES .........:
 COPYRIGHT .....: Vitaly Puzrin, 1999
 HISTORY .......: DATE        COMMENT                    
                  ---------------------------------------------------
                  25.06.1999   
\**************************************************************************/

#include    "common.h"
#include    "rpm.h"

#define TIMER_OVF_ENOUGHT   49
#define NO_PULSES_INTERVAL  60

WORD    wRpm;           //    (/)
BYTE    byBladeCnt;     //  
//BOOLEAN btRpmUpdate;    // = 1,     

WORD    wTimerOvfCnt;   //    ( 
                        //  

WORD    wFlashCnt;      //     

BOOLEAN btFirstLowRateFlash;    // FALSE -      
                                // (    )

/**************************************************************************\
      (  )
      :  -
      : -
\**************************************************************************/
void RpmInit(void)
{
    btFirstLowRateFlash = TRUE;
    wRpm = 0;

    //   INT1
    GIFR = 0x40;
    GIMSK |= 0x40;
    MCUCR = 0x02;   //  INT0  ,    .
    
    //   ,  
    //  
    wTimerOvfCnt = 0;
    TCNT0 = 0;
    TCCR0 = 0x03;   // FCK / 64 ( 62.5 KHz )
    TCNT0 = 0;
    TIMSK |= 0x02;  //    TMR0
}

/**************************************************************************\
        
      :  -
      : -
\**************************************************************************/
interrupt [INT0_vect] void RPM_PULSE_interrupt(void)
{
    long lTmp;

    GIMSK &= ~0x40;

    if(btFirstLowRateFlash)
    {
        //  ,    
        //  
        wTimerOvfCnt = 0;
        wFlashCnt = 0;
        TCNT0 = 0;
        TIFR = 0x02;
        TCCR0 = 0x03;   // FCK / 64 ( 62.5 KHz )
        TCNT0 = 0;
        TIMSK |= 0x02;  //    TMR0

        btFirstLowRateFlash = FALSE;
    }
    else
    {
        wFlashCnt++;
        // ,     
        if( wTimerOvfCnt > TIMER_OVF_ENOUGHT )
        {
            TCCR0 = 0;      //  TMR0
            GIMSK &= 0x40;  //    INT0
            TIMSK &= ~0x02; //    TMR0
            if(TIFR & 0x02)
                wTimerOvfCnt++;    //   

            lTmp = (62500L * 60L * (long)wFlashCnt);
            lTmp /= ((wTimerOvfCnt << 8) + TCNT0);
            lTmp /= byBladeCnt;
            wRpm = lTmp;

            //  
            btFirstLowRateFlash = TRUE;

            wTimerOvfCnt = 0;
            TCNT0 = 0;
            TCCR0 = 0x03;   // FCK / 64 ( 62.5 KHz )
            TCNT0 = 0;
            TIFR = 0x02;
            TIMSK |= 0x02;  //    TMR0

//            GIFR = 0x40;

        }
    }
    GIFR = 0x40;
    GIMSK |= 0x40;
}

/**************************************************************************\
      TMR0 (    8 )
      :  -
      : -
\**************************************************************************/
interrupt [TIMER0_OVF0_vect] void TIMER0_interrupt(void)
{
    wTimerOvfCnt++;

    //      ,  
    // 0     
    if( wTimerOvfCnt > NO_PULSES_INTERVAL )
    {
        wRpm = 0;
        btFirstLowRateFlash = TRUE;
        wTimerOvfCnt = 0;
    }
}

/**************************************************************************\
        ( TMR0)
      :  -
      : -
\**************************************************************************/
/*void StartLowRateRpm(void)
{
    btFirstLowRateFlash = TRUE;

    //   ,  
    //  
    wTimerOvfCnt = 0;
    TCNT0 = 0;
    TCCR0 = 0x03;   // FCK / 64 ( 62.5 KHz )
    TCNT0 = 0;
    TIMSK |= 0x02;  //    TMR0

    
    GIMSK |= 0x40;
}
*/
