/**************************************************************************\
 FILE ..........: TAHO.C
 AUTHOR ........: Vitaly Puzrin
 DESCRIPTION ...:   .  ,    ,
                    
 NOTES .........:
 COPYRIGHT .....: Vitaly Puzrin, 1999
 HISTORY .......: DATE        COMMENT                    
                  ---------------------------------------------------
                  25.06.1999   
\**************************************************************************/

#include    "common.h"
#include    "display.h"
#include    "time.h"
#include    "rpm.h"
#include    "kbd.h"

/**************************************************************************\
     .   .   
    .
      :  -
      : -
\**************************************************************************/
void C_task main(void)
{
    __disable_interrupt();
    
    MCUCR = 0x00;   //  SLEEP,     .
                    //  ,     .
    
    GIMSK = 0x00;   //   
    GIFR = 0xFF;    //   
    
    TIMSK = 0x00;   //    
    TIFR = 0xFF;    //   

    //    D    
    DDRD = 0x00;
    PORTD = 0xFF;

    //    B,  PB4  PB6 -    
    DDRB = 0x50;
    PORTB = 0xFF;

    //  
    DisplayInit();
    TimeInit();
    RpmInit();
    KbdInit();

    //     
    _EEGET(byBladeCnt, EE_BLADES_OFFS);
    if ((byBladeCnt == 0) || (byBladeCnt > BLADES_MAX))
        byBladeCnt = 1;

    __enable_interrupt();

//    StartLowRateRpm();
    while(TRUE)
    {
        if( btDisplayUpdate )
        {
            btDisplayUpdate = FALSE;
            RefreshDisplay();
//            StartLowRateRpm();
        }

        //     ,
        //   
        if( btKeyUpdate )
        {
            btKeyUpdate = FALSE;
            
            ProcessKey();
        }
    }
}

