/**************************************************************************\
 FILE ..........: TIME.C
 AUTHOR ........: Vitaly Puzrin
 DESCRIPTION ...:  
 NOTES .........:
 COPYRIGHT .....: Vitaly Puzrin, 1999
 HISTORY .......: DATE        COMMENT                    
                  ---------------------------------------------------
                  25.06.1999   
\**************************************************************************/

#include    "common.h"
#include    "time.h"
#include    "display.h"
#include    "rpm.h"
#include    "kbd.h"

#define     CNT_100_MS  6250

BOOLEAN btTimeUpdate;   // = 1,      
WORD wTime;             // ,    (  )

BOOLEAN btTimerOn;      // TRUE -  , FALSE - 

BYTE    byTcnt;         //   

BYTE    byDisplayRefreshCnt;    // 

/**************************************************************************\
     (  )
      :  -
      : -
\**************************************************************************/
void TimeInit(void)
{
    btTimerOn = FALSE;
    wTime = 0;
    byTcnt = 0;
    byDisplayRefreshCnt = 0;
    
    btTimeUpdate = FALSE;
    
    TCNT1 = 0;
    
    TCCR1A = 0x00;      //    OC1  PWM

    TCCR1B = 0x03;      //    FCK    64,
                        //  ,   

    OCR1 = TCNT1 + CNT_100_MS;

    TIFR  |= 0x40;      //     Output-Compare
    TIMSK |= 0x40;      //    Output-Compare
}

/**************************************************************************\
      OC1 (   0.1 )
      :  -
      : -
\**************************************************************************/
interrupt [TIMER1_COMP1_vect] void SYSTEM_TICK_interrupt(void)
{
    //     
    OCR1 += CNT_100_MS;

    // 3     ,
    //   .
    if( ++byDisplayRefreshCnt == 3 )
    {
        byDisplayRefreshCnt = 0;
        btDisplayUpdate = TRUE;
//        btTimeUpdate = TRUE;
//        btRpmUpdate = TRUE;
    }
    //    -   
    if( btTimerOn )    
    {
        if (++byTcnt == 10)
        {
            byTcnt = 0;
            if( ++wTime == 60000)
                wTime = 0;
//            btTimeUpdate = TRUE;
        }
    }

    //      
    ScanKbd();
}

/**************************************************************************\
      (, , )
      :  -
      : -
\**************************************************************************/
void SwitchTimerState(void)
{
    //   ,   
    if (btTimerOn)
        btTimerOn = FALSE;
    else
        //   ,   ,   
        if (wTime)
        {
            wTime = 0;
            byTcnt = 0;
        }
        //   ,   
        else
            btTimerOn = TRUE;

    btTimeUpdate = TRUE;
}

