/**************************************************************************\
 FILE ..........: KBD.C
 AUTHOR ........: Vitaly Puzrin
 DESCRIPTION ...:   (    )
 NOTES .........:
 COPYRIGHT .....: Vitaly Puzrin, 1999
 HISTORY .......: DATE        COMMENT                    
                  ---------------------------------------------------
                  25.06.1999   
\**************************************************************************/

#include    "common.h"
#include    "display.h"
#include    "time.h"
#include    "rpm.h"
#include    "kbd.h"

#define     ST_WAIT_KEY     0
#define     ST_CHECK_KEY    1
#define     ST_RELEASE_WAIT 2

#define     KEY_BLADES      0x01    //     
#define     KEY_MODE        0x02    //      (/)
#define     KEY_TIMER       0x04    //     


BOOLEAN btKeyUpdate;    // = 1,     
BYTE    byKeyCode;      //   

BYTE    byScanState;    //     
BYTE    byCheckedKey;   // . .   
BYTE    byCheckKeyCnt;  // . .   / 

#define KeyCode     ((PINB & 0x07) ^ 0x07)  // ,     
#define PRESS_CNT   1   // ,    
#define RELEASE_CNT 2   // ,     

/**************************************************************************\
      (  )
      :  -
      : -
\**************************************************************************/
void KbdInit(void)
{
    btKeyUpdate = FALSE;
    byScanState = ST_WAIT_KEY;
}

/**************************************************************************\
     
      :  -
      : -
\**************************************************************************/
void ScanKbd(void)
{
    switch (byScanState)
    {
        case ST_WAIT_KEY:
            //     ,     .
            if (KeyCode != 0)
            {
                byCheckedKey = KeyCode;
                byCheckKeyCnt = PRESS_CNT;
                byScanState = ST_CHECK_KEY;
            }
            break;
            
        case ST_CHECK_KEY:
            //     , 
            //     ,   
            //   
            if (byCheckedKey == KeyCode)
            {
                byCheckKeyCnt--;
                if (!byCheckKeyCnt)
                {
                    btKeyUpdate = TRUE;
                    byKeyCode = byCheckedKey;
                    byScanState = ST_RELEASE_WAIT;
                    byCheckKeyCnt = RELEASE_CNT;
                }
            }
            //   ,   ,
            //    
            else
                byScanState = ST_WAIT_KEY;
            break;
            
        case ST_RELEASE_WAIT:
            //        
            // ,     
            if (KeyCode != 0)
                byCheckKeyCnt = RELEASE_CNT;
            else
            {
                byCheckKeyCnt--;    
                if (!byCheckKeyCnt)
                    byScanState = ST_WAIT_KEY;
            }
            break;
    }
}

/**************************************************************************\
      .
      :  -
      : -
\**************************************************************************/
void ProcessKey(void)
{
    switch (byKeyCode)
    {
        case KEY_BLADES:
            //      
            if (!btRpmMode)
                break;
                
            if (++byBladeCnt > BLADES_MAX)
                byBladeCnt = 1;
            _EEPUT(EE_BLADES_OFFS, byBladeCnt);

//            btRpmUpdate = TRUE;
            break;
            
        case KEY_MODE:
            //      
            btRpmMode = !btRpmMode;
//            btTimeUpdate = TRUE;
//            btRpmUpdate = TRUE;
            break;
            
        case KEY_TIMER:
            //     
            if (btRpmMode)
                break;

            SwitchTimerState();
            break;
            
        default:
            break;
    }
}
